module OW_parms_areal

use sep
use OW_type

implicit none

logical,public, save				:: encode,every,stereo,interf,timeshift
type (axis) ,public, save				:: kxm, kix, kiz, h, w, x, xm, z, sh, th
type (dat_grid)	 ,public, save			:: rec, sou
type (mod_grid)	 ,public, save			:: img
type (velo) ,public, save				:: v
integer	 ,public, save				:: nref,iwb,ikxa,tapertr,padtraces,dref,imgxn,azn,axn
integer	 ,public, save				:: nsh_img,isp,nphi,n_wind,n_sampt,itzero,nwbott,wnw,ndip
real ,public, save					:: xmin,xmax,ymin,ymax,zmin,zmax,pi,dwbott
real, public, save					:: ddip,vsal,dphi,ophi,deltat,eps,geodip,amax
real,public,save,allocatable				:: windf(:),dips(:)

contains

subroutine owparam(migrate)

logical						:: migrate
real						:: d_sampt,t0,tzero,wbott
integer						:: iw,nt, i, m

if (migrate) then

 call from_history("n1",rec%h%n);	call from_history("d1",rec%h%d);	call from_history("o1",rec%h%o)
 call from_history("n3",rec%w%n);	call from_history("d3",rec%w%d);	call from_history("o3",rec%w%o)
 call from_history("n4",rec%x%n);	call from_history("d4",rec%x%d);	call from_history("o4",rec%x%o)  

 call from_aux("sou","n1",sou%h%n);	call from_aux("sou","d1",sou%h%d);	call from_aux("sou","o1",sou%h%o)
 call from_aux("sou","n3",sou%w%n);	call from_aux("sou","d3",sou%w%d);	call from_aux("sou","o3",sou%w%o)
 call from_aux("sou","n4",sou%x%n);	call from_aux("sou","d4",sou%x%d);	call from_aux("sou","o4",sou%x%o)  

 call from_aux("vel","n1",v%z%n);	call from_aux("vel","d1",v%z%d);	call from_aux("vel","o1",v%z%o)
 call from_aux("vel","n2",v%xm%n);	call from_aux("vel","d2",v%xm%d);	call from_aux("vel","o2",v%xm%o)

 if (sou%w%n .ne. rec%w%n) then
    call seperr("# source freq. .ne. # receiver freq.")
 end if
 if (sou%x%n .ne. rec%x%n) then
    call seperr("# source planes. .ne. # receiver planes")
 end if
 if (sou%h%n .ne. rec%h%n) then
    call seperr("# source traces. .ne. # areal shot traces")
 end if
 if (sou%w%d .ne. rec%w%d) then
    call seperr("source freq.interval .ne. receiver freq.interval")
 end if
 if (sou%h%d .ne. rec%h%d) then
    call seperr("source trace interval .ne. areal shot trace interval")
 end if
 if (sou%x%d .ne. rec%x%d) then
    call seperr("source plane interval .ne. areal shot plane interval")
 end if
 if (sou%w%o .ne. rec%w%o) then
    call seperr("source freq.origin .ne. receiver freq.origin")
 end if
 if (sou%x%o .ne. rec%x%o) then
    call seperr("source plane origin .ne. areal shot plane origin")
 end if
 if (sou%w%o .ne. rec%w%o) then
    call seperr("source origin .ne. areal shot origin")
 end if

 !!  get parameters
  call from_param("nrefvel",nref) 
  call from_param("xmin",xmin) 
  call from_param("xmax",xmax)
  call from_param("ymin",ymin,0.)
  call from_param("ymax",ymax,0.)
  call from_param("zmin",zmin,0.)
  call from_param("zmax",zmax)

  if (xmin < v%xm%o ) call seperr("Min.x-image space < Min.x-velocity")
  if (xmax > v%xm%o+(v%xm%n-1)*v%xm%d ) call seperr("Max.x-image space > Max.x-velocity")
 
  if (zmin < v%xm%o ) call seperr("Min.z-image space < Min.z-velocity")
  if (zmax > v%z%o+(v%z%n-1)*v%z%d ) call seperr("Max.z-image space > Max.z-velocity")

  img%z%n=floor((zmax-zmin)/v%z%d)+1
  img%z%o=zmin
  img%z%d=v%z%d

  img%xm%n=rec%h%n
  img%xm%d=rec%h%d
  img%xm%o=rec%h%o

  call from_param("wbott",wbott,0.)
  call from_param("timeshift",timeshift,.false.)
  if (timeshift) then
     call from_param("nth",img%th%n,121)
     call from_param("oth",img%th%o,-0.24)
     call from_param("dth",img%th%d,0.004)
  else
     call from_param("nh",img%sh%n,1)
     call from_param("oh",img%sh%o,0.)
     call from_param("dh",img%sh%d,0.)
  end if
  call from_param("wbott",wbott,0.)
  call from_param("vsal",vsal)
  call from_param("traces_in_taper",tapertr,0)
  call from_param("padtraces",padtraces,tapertr)
  call from_param("every",every,.false.)
  call from_param("encode",encode,.false.)
  call from_param("stereo",stereo,.false.)
  if (stereo) then
     call from_param("azn",azn,51)
     call from_param("axn",axn,5)
     call from_param("geodip",geodip,10.)
     call from_param("ndip",ndip,51)
     amax=atan(azn*img%z%d/(axn*img%xm%d))
     ddip=2*amax/(ndip-1)
     allocate(dips(ndip))
     do i=1,ndip
        dips(i)=(i-1)*ddip-amax
     end do
     write(0,*) amax,ddip
     write(0,*) dips
     call from_param("ddip",ddip,2.)
!     call from_param("azn",azn,31)
!     call from_param("axn",axn,11)
!     call from_param("geodip",geodip,10.)
!     call from_param("ddip",ddip,2.)
!     if (dipfac .gt. 1) dipfac=dipfac/100.
  end if

  call from_param("interf",interf,.false.)
  if (interf) call from_param("wnw",wnw,5)

  if (not(encode)) then
     call from_param("deltat",deltat,0.1)
     call from_param("dt",d_sampt)
     call from_param("tzero",tzero,0.)
     itzero=int(tzero/d_sampt)
     n_sampt=1;
     do while (rec%w%n > n_sampt)
        n_sampt=n_sampt*2
     end do 
     n_sampt=n_sampt*2

     n_wind=int(deltat/d_sampt)
     if (mod(n_wind,2) == 0) n_wind=n_wind+1
     deltat=n_wind*d_sampt 
     t0=-(n_wind-1)*d_sampt

     write(0,*) n_sampt, n_wind,t0,deltat , d_sampt
  end if

  wbott=int(wbott/img%z%d)*img%z%d
  nwbott=int(wbott/img%z%d)+1
  dwbott=wbott/2.

! if (wbott.ne.0.) then
!    call to_history("n1",rec%h%n,"dat");call to_history("d1",rec%h%d,"dat");call to_history("o1",rec%h%o,"dat")
!    call to_history("n3",rec%w%n,"dat");call to_history("d3",rec%w%d,"dat");call to_history("o3",rec%w%o,"dat")
!    call to_history("n4",rec%x%n,"dat");call to_history("d4",rec%x%d,"dat");call to_history("o4",rec%x%o,"dat")  
!    call to_history("n2",1,"dat"); call to_history("d2",1,"dat"); call to_history("o2",1,"dat")
!    call to_history("n5",1,"dat"); call to_history("d5",1,"dat"); call to_history("o5",1,"dat")  
!    call to_history("esize",8,"dat")
! end if

!----------------------------------------------
!
! Migration output
!

 call to_history("n1",img%z%n) ; call to_history("d1",img%z%d) ; call to_history("o1",img%z%o)

 if (timeshift) then
    call to_history("n2",img%th%n) ; call to_history("d2",img%th%d/2.) ; call to_history("o2",2*img%th%o)
 else
    call to_history("n2",img%sh%n) ; call to_history("d2",img%sh%d) ; call to_history("o2",img%sh%o)
 end if

 call to_history("n3",img%xm%n); call to_history("d3",img%xm%d); call to_history("o3",img%xm%o)  

 if (every) then
    call to_history("n4",rec%x%n); call to_history("d4",rec%x%d); call to_history("o4",rec%x%o)
 else
    call to_history("n4",1); call to_history("d4",1); call to_history("o4",0)
 end if

 call to_history("n5",1); call to_history("d5",1); call to_history("o5",0)  
 call to_history("esize",4)

if(exist_file("G1")) then
 call to_history("n1",img%z%n,"G1") ; call to_history("d1",img%z%d,"G1") ; call to_history("o1",img%z%o,"G1")
 call to_history("n2",img%sh%n,"G1"); call to_history("d2",img%sh%d,"G1"); call to_history("o2",img%sh%o,"G1")
 call to_history("n3",img%xm%n,"G1"); call to_history("d3",img%xm%d,"G1"); call to_history("o3",img%xm%o,"G1")  
 call to_history("n4",floor(rec%w%n/10.),"G1"); call to_history("d4",rec%w%d*10,"G1"); call to_history("o4",rec%w%o,"G1")
 call to_history("n5",1,"G1"); call to_history("d5",1,"G1"); call to_history("o5",1,"G1")  
 call to_history("esize",4,"G1")
end if

if(exist_file("ws")) then
 call to_history("n1",img%z%n,"ws") ; call to_history("d1",img%z%d,"ws") ; call to_history("o1",img%z%o,"ws")
 call to_history("n2",img%xm%n,"ws"); call to_history("d2",img%xm%d,"ws"); call to_history("o2",img%xm%o,"ws")  
 if (encode) then 
    call to_history("n3",rec%w%n,"ws"); call to_history("d3",rec%w%d,"ws"); call to_history("o3",rec%w%o,"ws")
    call to_history("esize",8,"ws")
 else
    call to_history("n3",2*n_wind-1,"ws"); call to_history("d3",d_sampt,"ws"); call to_history("o3",t0,"ws")
    call to_history("esize",4,"ws")
 end if
! call to_history("n3",n_sampt,"ws"); call to_history("d3",d_sampt,"ws"); call to_history("o3",0.,"ws")
 call to_history("n4",1,"ws"); call to_history("d4",1.,"ws"); call to_history("o4",1.,"ws")
 call to_history("n5",1,"ws"); call to_history("d5",1.,"ws"); call to_history("o5",1.,"ws")  
 call to_history("esize",8,"ws")
end if

if(exist_file("wr")) then
 call to_history("n1",img%z%n,"wr") ; call to_history("d1",img%z%d,"wr") ; call to_history("o1",img%z%o,"wr")
 call to_history("n2",img%xm%n,"wr"); call to_history("d2",img%xm%d,"wr"); call to_history("o2",img%xm%o,"wr")  
 if (encode) then
    call to_history("n3",rec%w%n,"wr"); call to_history("d3",rec%w%d,"wr"); call to_history("o3",rec%w%o,"wr")
    call to_history("esize",8,"wr")
 else
    call to_history("n3",2*n_wind-1,"wr"); call to_history("d3",d_sampt,"wr"); call to_history("o3",t0,"wr")
    call to_history("esize",4,"wr")
 end if
! call to_history("n3",n_sampt,"wr"); call to_history("d3",d_sampt,"wr"); call to_history("o3",0.,"wr")
 call to_history("n4",1,"wr"); call to_history("d4",1.,"wr"); call to_history("o4",1.,"wr")
 call to_history("n5",1,"wr"); call to_history("d5",1.,"wr"); call to_history("o5",1.,"wr")  
 call to_history("esize",8,"wr")
end if

if(exist_file("cwss")) then
 call to_history("n1",azn,"cwss") ; call to_history("d1",v%z%d,"cwss") ; call to_history("o1",0.,"cwss")
 call to_history("n2",ndip,"cwss"); call to_history("d2",ddip,"cwss"); call to_history("o2",-amax,"cwss")
 call to_history("esize",4,"cwss")
end if

pi=4*atan(1.)
isp=abs(floor(rec%h%o/rec%h%d)) + 1
!--------------------------------------------------
! Frequency vector
! no zero frequency component
!
rec%w%o   = 2*pi * rec%w%o
rec%w%d   = 2*pi * rec%w%d
allocate(rec%w%all(rec%w%n))
do iwb = 1,rec%w%n
   rec%w%all(iwb) = rec%w%o + (iwb - 1) * rec%w%d
end do

!--------------------------------------------------
! Wavenumber vector
!
kxm%n = img%xm%n
allocate(kxm%all(kxm%n))
kxm%all=0.
if(kxm%n/=1) then
  m = kxm%n/2
  do i=1,m+1
     kxm%all(i)=i-1
  end do
  do i=m+2,kxm%n
     kxm%all(i)=i-kxm%n-1
  end do
else
  kxm%all=0. !! make sure k=0 if n=1
end if

kxm%all = kxm%all / (kxm%n*img%xm%d)      !! 1/length
kxm%all = 2 * PI * kxm%all     !! radians

if (stereo) then
   !--------------------------------------------------
   ! KIX vector - imaging
   !
   kix%n = axn
   allocate(kix%all(kix%n))
   kix%all=0.
   if(kix%n/=1) then
     m = kix%n/2
     do i=1,m+1
        kix%all(i)=i-1
     end do
     do i=m+2,kix%n
        kix%all(i)=i-kix%n-1
     end do
   else
     kix%all=0. !! make sure k=0 if n=1
   end if

   kix%all = kix%all / (kix%n*img%xm%d)      !! 1/length
   kix%all = 2 * PI * kix%all     !! radians
   kix%d = kix%all(2) - kix%all(1)

   !--------------------------------------------------
   ! KIZ vector - imaging
   !
   kiz%n = axn
   allocate(kiz%all(kiz%n))
   kiz%all=0.
   if(kiz%n/=1) then
     m = kiz%n/2
     do i=1,m+1
        kiz%all(i)=i-1
     end do
     do i=m+2,kiz%n
        kiz%all(i)=i-kiz%n-1
     end do
   else
     kiz%all=0. !! make sure k=0 if n=1
   end if

   kiz%all = kiz%all / (kiz%n*img%z%d)      !! 1/length
   kiz%all = 2 * PI * kiz%all     !! radians
!   write(0,*) minval(kix%all),maxval(kix%all),kix%all(kix%n)
end if



!----------------------------------------------------
write(0,*) "   PARM   "
write(0,*) "=========="
write(0,*) "PARAMETERS"
write(0,*) "=========="
write(0,*) //
write(0,*) "no.ref.velocities   = ",nref
write(0,*) "min.x-coord         = ",xmin
write(0,*) "max.x-coord         = ",xmax
write(0,*) "min.y-coord         = ",ymin
write(0,*) "max.y-coord         = ",ymax
write(0,*) "min.depth           = ",zmin
write(0,*) "max.depth           = ",zmax
write(0,*) "max.limit velocity  = ",vsal
write(0,*) "traces in taper     = ",tapertr
write(0,*) "padded traces       = ",padtraces
write(0,*) //
write(0,*) "============"
write(0,*) "HEADER WORDS"
write(0,*) "============"
write(0,*) //
write(0,*) "SHOTS"
write(0,*) "====="
write(0,*) "number of recv  = ", rec%h%n
write(0,*) "recv spacing    = ", rec%h%d
write(0,*) "min.recv offset = ", rec%h%o
write(0,*) "number of freq  = ", rec%w%n
write(0,*) "freq spacing    = ", rec%w%d/(2*pi)
write(0,*) "minimum freq    = ", rec%w%o/(2*pi)
write(0,*) "number of shots = ", rec%x%n
write(0,*) "shot spacing    = ", rec%x%d
write(0,*) "min.shot-x      = ", rec%x%o
write(0,*) //
write(0,*) "SOURCE FUNCTION"
write(0,*) "==============="
write(0,*) "no.of traces    = ", sou%h%n
write(0,*) "trace spacing   = ", sou%h%d
write(0,*) "min.trace-x     = ", sou%h%o
write(0,*) "number of freq  = ", sou%w%n
write(0,*) "freq spacing    = ", sou%w%d
write(0,*) "minimum freq    = ", sou%w%o
write(0,*) "no.of s.fnct    = ", sou%x%n
write(0,*) "s.fnct spacing  = ", sou%x%d
write(0,*) "min.s.fnct-x    = ", sou%x%o
write(0,*) //
write(0,*) "VELOCITY MODEL"
write(0,*) "=============="
write(0,*) "no.of traces    = ", v%xm%n
write(0,*) "trace spacing   = ", v%xm%d
write(0,*) "min.trace-x     = ", v%xm%o
write(0,*) "no.depth samples= ", v%z%n
write(0,*) "depth interval  = ", v%z%d
write(0,*) "minimum depth   = ", v%z%o
write(0,*) //
write(0,*) "IMAGE SPACE"
write(0,*) "==========="
write(0,*) "no.of traces    = ", img%xm%n
write(0,*) "trace spacing   = ", img%xm%d
write(0,*) "min.trace-x     = ", img%xm%o
write(0,*) "no.depth samples= ", img%z%n
write(0,*) "depth interval  = ", img%z%d
write(0,*) "minimum depth   = ", img%z%o
write(0,*) //
write(0,*) "WAVENUMBER"
write(0,*) "=========="
write(0,*) "no.wavenumbers  = ", kxm%n
write(0,*) "waveno.spacing  = ", kxm%d
write(0,*) "waveno.origin   = ", kxm%o
write(0,*) //
!write(0,*) kxm%all
end if
end subroutine

end module
